var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { getDateInputValue } from '../../Utils/DateUtils';
var CellEditorDate = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, field = _a.field, rowData = _a.rowData, rowKeyField = _a.rowKeyField;
    var fieldValue = rowData[field];
    var value = fieldValue && getDateInputValue(fieldValue);
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.dateInput, type: 'date', value: value || '', onChange: function (event) {
            var _a;
            var targetValue = event.currentTarget.value;
            dispatch(ActionType.ChangeRowData, { newValue: __assign(__assign({}, rowData), (_a = {}, _a[field] = targetValue ? new Date(targetValue) : null, _a)) });
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(ActionType.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorDate;