var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { ActionType } from '../enums';
import { getCopyOfArrayAndInsertOrReplaceItem } from './ArrayUtils';
import { changeCellEditorToCellTextHandler, changeCellTextToCellEditorHandler } from './CellUtils';
import { getSortedColumns } from './HeadRowUtils';
export var wrapDispatch = function (_a) {
    var columns = _a.columns, data = _a.data, _b = _a.editableCells, editableCells = _b === void 0 ? [] : _b, _c = _a.onEvent, onEvent = _c === void 0 ? function () { } : _c, _d = _a.onDataChange, onDataChange = _d === void 0 ? function () { } : _d, onOptionChange = _a.onOptionChange, rowKeyField = _a.rowKeyField, _e = _a.selectedRows, selectedRows = _e === void 0 ? [] : _e, virtualScrolling = _a.virtualScrolling;
    return function (action, actionData) {
        switch (action) {
            case ActionType.OpenEditor:
                changeCellTextToCellEditorHandler(actionData.cell, editableCells, onOptionChange);
                break;
            case ActionType.CloseEditor:
                changeCellEditorToCellTextHandler(actionData.cell, editableCells, onOptionChange);
                break;
            case ActionType.ChangeFilterRow:
                var newColumns = getCopyOfArrayAndInsertOrReplaceItem(actionData.column, 'key', columns);
                onOptionChange({ columns: newColumns });
                break;
            case ActionType.ChangeRowData:
                var newData = getCopyOfArrayAndInsertOrReplaceItem(actionData.newValue, rowKeyField, data);
                onDataChange(newData);
                break;
            case ActionType.SelectRow:
                onOptionChange({ selectedRows: __spreadArrays(selectedRows, [actionData.rowKeyValue]) });
                break;
            case ActionType.DeselectRowData:
                onOptionChange({ selectedRows: __spreadArrays(selectedRows).filter(function (s) { return s !== actionData.rowKeyValue; }) });
                break;
            case ActionType.ChangeSorting:
                var sortedColumns = getSortedColumns(columns, actionData.column);
                onOptionChange({ columns: sortedColumns });
                break;
            case ActionType.ScrollTable:
                if (virtualScrolling) {
                    var scrollPosition = actionData.scrollTop;
                    if (virtualScrolling) {
                        onOptionChange({ virtualScrolling: __assign(__assign({}, virtualScrolling), { scrollPosition: scrollPosition }) });
                    }
                }
                break;
        }
        onEvent(action, actionData);
    };
};